image: node:10.22-alpine

variables:
  BUILD_DIR: $CI_BUILDS_DIR

stages:
  - build
  - deploy

build_frontend_homolog:
  stage: build
  only:
    changes:
      - front-end/**/*
      - dls/**/*
      - .gitlab-ci.yml
  except:
    - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd front-end
    - yarn install
    - touch .env
    - echo "VUE_APP_API_URL=$VUE_APP_API_URL" >> .env
    - echo "VUE_APP_URL=$VUE_APP_URL" >> .env
  script:
    - yarn build
  artifacts:
    paths:
      - $BUILD_DIR/front-end/dist/

build_admin_homolog:
  stage: build
  only:
    changes:
      - admin/**/*
      - dls/**/*
      - .gitlab-ci.yml
  except:
    - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd admin
    - yarn install
    - touch .env
    - echo "VUE_APP_API_URL=$VUE_APP_API_URL" >> .env
    - echo "VUE_APP_URL=$VUE_APP_URL" >> .env
  script:
    - yarn build
  artifacts:
    paths:
      - $BUILD_DIR/admin/dist/

build_frontend_prod:
  stage: build
  only:
    changes:
      - front-end/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd front-end
    - yarn install
    - touch .env
    - echo "VUE_APP_API_URL=$VUE_APP_API_URL" >> .env
    - echo "VUE_APP_URL=$VUE_APP_URL" >> .env
  script:
    - yarn build
  artifacts:
    paths:
      - $BUILD_DIR/front-end/dist/

build_admin_prod:
  stage: build
  only:
    changes:
      - admin/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd admin
    - yarn install
    - touch .env
    - echo "VUE_APP_API_URL=$VUE_APP_API_URL" >> .env
    - echo "VUE_APP_URL=$VUE_APP_URL" >> .env
  script:
    - yarn build
  artifacts:
    paths:
      - $BUILD_DIR/admin/dist/

deploy_frontend_homolog:
  stage: deploy
  environment:
    name: homolog
  only:
    changes:
      - front-end/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - dev
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd front-end
  script:
    - aws s3 sync dist $FRONTEND_HOMOLOG_S3_URL --region sa-east-1 --acl public-read --delete
    - aws cloudfront create-invalidation --distribution-id $FRONTEND_HOMOLOG_DISTRIBUTION_ID --paths "/*"
    - aws s3 cp $FRONTEND_HOMOLOG_S3_URL/index.html $FRONTEND_HOMOLOG_S3_URL/index.html --region sa-east-1 --metadata-directive REPLACE --cache-control no-store,max-age=0 --acl public-read

deploy_admin_homolog:
  stage: deploy
  environment:
    name: homolog
  only:
    changes:
      - admin/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - dev
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd admin
  script:
    - aws s3 sync dist $ADMIN_HOMOLOG_S3_URL --region sa-east-1 --acl public-read --delete
    - aws cloudfront create-invalidation --distribution-id $ADMIN_HOMOLOG_DISTRIBUTION_ID --paths "/*"
    - aws s3 cp $ADMIN_HOMOLOG_S3_URL/index.html $ADMIN_HOMOLOG_S3_URL/index.html --region sa-east-1 --metadata-directive REPLACE --cache-control no-store,max-age=0 --acl public-read

deploy_frontend_prod:
  stage: deploy
  environment:
    name: prod
  only:
    changes:
      - front-end/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd front-end
  script:
    - aws s3 sync dist $FRONTEND_PROD_S3_URL --region sa-east-1 --acl public-read --delete
    - aws cloudfront create-invalidation --distribution-id $FRONTEND_PROD_DISTRIBUTION_ID --paths "/*"
    - aws s3 cp $FRONTEND_PROD_S3_URL/index.html $FRONTEND_PROD_S3_URL/index.html --region sa-east-1 --metadata-directive REPLACE --cache-control no-store,max-age=0 --acl public-read

deploy_admin_prod:
  stage: deploy
  environment:
    name: prod
  only:
    changes:
      - admin/**/*
      - dls/**/*
      - .gitlab-ci.yml
    refs:
      - master
  before_script:
    - apk add py3-pip
    - pip3 install --upgrade --user awscli
    - export PATH=~/.local/bin:$PATH
    - cd admin
  script:
    - aws s3 sync dist $ADMIN_PROD_S3_URL --region sa-east-1 --acl public-read --delete
    - aws cloudfront create-invalidation --distribution-id $ADMIN_PROD_DISTRIBUTION_ID --paths "/*"
    - aws s3 cp $ADMIN_PROD_S3_URL/index.html $ADMIN_PROD_S3_URL/index.html --region sa-east-1 --metadata-directive REPLACE --cache-control no-store,max-age=0 --acl public-read
